# Matrix Diagram for the Mine Keyboard
## Matrix for "LAYOUT_all":
```
┌──┐ ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐      ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐           ┌──┐
│0A│ │0B││1B│ │0C││1C│ │0D││1D│      │9D││AD│ │0E││0F│ │0G││1G│ │AG││0H│           │0J│
└──┘ └──┘└──┘ └──┘└──┘ └──┘└──┘      └──┘└──┘ └──┘└──┘ └──┘└──┘ └──┘└──┘           └──┘
┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──────┐  ┌──┐┌──┐┌──┐┌──┐
│1A││AA││2B││AB││2C││AC││2D│         │8D││1E││AE││1F││AF││2G││9G    │  │1H││0I││AI││1J│
└──┘└──┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──────┘  └──┘└──┘└──┘└──┘
┌────┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌────┐  ┌──┐┌──┐┌──┐┌──┐
│2A  ││9A││3B││9B││3C││9C│         │7D││2E││9E││2F││9F││3G││8G││7H  │  │2H││1I││9I││8I│
└────┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──┘└────┘  └──┘└──┘└──┘│  │
┌─────┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌───────┐  ┌──┐┌──┐┌──┐│  │
│3A   ││8A││4B││8B││4C││8C│         │6D││3E││8E││3F││8F││4G││7G     │  │3H││2I││7I││  │
└─────┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└───────┘  └──┘└──┘└──┘└──┘
┌───┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐     ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌─────────┐  ┌──┐┌──┐┌──┐┌──┐
│4A ││7A││5B││7B││5C││7C││3D│     │5D││4E││5E││7E││4F││7F││5G       │  │4H││3I││6I││5I│
└───┘└──┘└──┘└──┘└──┘└──┘└──┘     └──┘└──┘└──┘└──┘└──┘└──┘└─────────┘  └──┘└──┘└──┘│  │
┌───┐┌───┐   ┌───┐┌─────────┐     ┌───────┐┌───┐           ┌───┐┌───┐      ┌──┐┌──┐│  │
│5A ││6A │   │6B ││6C       │     │4D     ││6E │           │5F ││6F │ ┌──┐ │AH││4I││  │
└───┘└───┘   └───┘└─────────┘     └───────┘└───┘           └───┘└───┘ │5H│ └──┘└──┘└──┘
                                                                      └──┘
                                                                  ┌──┐┌──┐┌──┐
                                                                  │6H││8H││9H│
                                                                  └──┘└──┘└──┘
```

## Matrix for "LAYOUT_1800_alice_ansi":
```
┌──┐ ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐      ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐           ┌──┐
│0A│ │0B││1B│ │0C││1C│ │0D││1D│      │9D││AD│ │0E││0F│ │0G││1G│ │AG││0H│           │0J│
└──┘ └──┘└──┘ └──┘└──┘ └──┘└──┘      └──┘└──┘ └──┘└──┘ └──┘└──┘ └──┘└──┘           └──┘
┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──────┐  ┌──┐┌──┐┌──┐┌──┐
│1A││AA││2B││AB││2C││AC││2D│         │8D││1E││AE││1F││AF││2G││9G    │  │1H││0I││AI││1J│
└──┘└──┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──────┘  └──┘└──┘└──┘└──┘
┌────┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌────┐  ┌──┐┌──┐┌──┐┌──┐
│2A  ││9A││3B││9B││3C││9C│         │7D││2E││9E││2F││9F││3G││8G││7H  │  │2H││1I││9I││8I│
└────┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──┘└────┘  └──┘└──┘└──┘│  │
┌─────┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌───────┐  ┌──┐┌──┐┌──┐│  │
│3A   ││8A││4B││8B││4C││8C│         │6D││3E││8E││3F││8F││4G││7G     │  │3H││2I││7I││  │
└─────┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└───────┘  └──┘└──┘└──┘└──┘
┌───────┐┌──┐┌──┐┌──┐┌──┐┌──┐     ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌─────────┐  ┌──┐┌──┐┌──┐┌──┐
│4A     ││5B││7B││5C││7C││3D│     │5D││4E││5E││7E││4F││7F││5G       │  │4H││3I││6I││5I│
└───────┘└──┘└──┘└──┘└──┘└──┘     └──┘└──┘└──┘└──┘└──┘└──┘└─────────┘  └──┘└──┘└──┘│  │
┌───┐┌───┐   ┌───┐┌─────────┐     ┌───────┐┌───┐           ┌───┐┌───┐      ┌──┐┌──┐│  │
│5A ││6A │   │6B ││6C       │     │4D     ││6E │           │5F ││6F │ ┌──┐ │AH││4I││  │
└───┘└───┘   └───┘└─────────┘     └───────┘└───┘           └───┘└───┘ │5H│ └──┘└──┘└──┘
                                                                      └──┘
                                                                  ┌──┐┌──┐┌──┐
                                                                  │6H││8H││9H│
                                                                  └──┘└──┘└──┘
```

## Matrix for "LAYOUT_1800_alice_iso":
```
┌──┐ ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐      ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐ ┌──┐┌──┐           ┌──┐
│0A│ │0B││1B│ │0C││1C│ │0D││1D│      │9D││AD│ │0E││0F│ │0G││1G│ │AG││0H│           │0J│
└──┘ └──┘└──┘ └──┘└──┘ └──┘└──┘      └──┘└──┘ └──┘└──┘ └──┘└──┘ └──┘└──┘           └──┘
┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──────┐  ┌──┐┌──┐┌──┐┌──┐
│1A││AA││2B││AB││2C││AC││2D│         │8D││1E││AE││1F││AF││2G││9G    │  │1H││0I││AI││1J│
└──┘└──┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──────┘  └──┘└──┘└──┘└──┘
┌────┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌────┐  ┌──┐┌──┐┌──┐┌──┐
│2A  ││9A││3B││9B││3C││9C│         │7D││2E││9E││2F││9F││3G││8G││7G  │  │2H││1I││9I││8I│
└────┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──┘└┐   │  └──┘└──┘└──┘│  │
┌─────┐┌──┐┌──┐┌──┐┌──┐┌──┐         ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐│   │  ┌──┐┌──┐┌──┐│  │
│3A   ││8A││4B││8B││4C││8C│         │6D││3E││8E││3F││8F││4G││6G││   │  │3H││2I││7I││  │
└─────┘└──┘└──┘└──┘└──┘└──┘         └──┘└──┘└──┘└──┘└──┘└──┘└──┘└───┘  └──┘└──┘└──┘└──┘
┌───┐┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐     ┌──┐┌──┐┌──┐┌──┐┌──┐┌──┐┌─────────┐  ┌──┐┌──┐┌──┐┌──┐
│4A ││7A││5B││7B││5C││7C││3D│     │5D││4E││5E││7E││4F││7F││5G       │  │4H││3I││6I││5I│
└───┘└──┘└──┘└──┘└──┘└──┘└──┘     └──┘└──┘└──┘└──┘└──┘└──┘└─────────┘  └──┘└──┘└──┘│  │
┌───┐┌───┐   ┌───┐┌─────────┐     ┌───────┐┌───┐           ┌───┐┌───┐      ┌──┐┌──┐│  │
│5A ││6A │   │6B ││6C       │     │4D     ││6E │           │5F ││6F │ ┌──┐ │AH││4I││  │
└───┘└───┘   └───┘└─────────┘     └───────┘└───┘           └───┘└───┘ │5H│ └──┘└──┘└──┘
                                                                      └──┘
                                                                  ┌──┐┌──┐┌──┐
                                                                  │6H││8H││9H│
                                                                  └──┘└──┘└──┘
```