# Matrix Diagram for Compensator

```
┌───────┐┌───────────────┐┌───────────┐┌───────────────────────────────────────────────────────────┐┌───────────┐┌───────────────┐┌───────┐
│00 │01 ││02 │03 │04 │05 ││06 │07 │08 ││09   │0A │0B │0C │0D │0E │0F │0G │0H │0I │0J │0K │0L │0M   ││0N │0O │0P ││0Q │0R │0S │0T ││0U │0V │
├───┼───┤├───┼───┼───┼───┤├───┼───┼───│├─────┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴─────┤├───┼───┼───│├───┼───┼───┼───┤├───┼───┤
│10 │11 ││12 │13 │14 │15 ││16 │17 │18 ││19    │1A │1B │1C │1D │1E │1F │1G │1H │1I │1J │1K │1L      ││1M │1N │1O ││1P │1Q │1R │1S ││1T │1U │
├───┼───┤├───┼───┼───┼───┤└───┼───┼───┘├────┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴────┬───┤└───┼───┼───┘├───┼───┼───┼───┤├───┼───┤
│20 │21 ││22 │23 │24 │25 │    │26 │    │27  │28 │29 │2A │2B │2C │2D │2E │2F │2G │2H │2I │2J    │2K │    │1L │    │2M │2N │2O │2P ││2Q │2R │
├───┼───┤├───┼───┼───┼───┤┌───┼───┼───┐├────┴┬──┴┬──┴──┬┴───┴───┴───┴───┴───┴───┴──┬┴───┴┬───┬─┴───┤┌───┼───┼───┐├───┼───┼───┼───┤├───┼───┤
│31 │32 ││33 │34 │35 │36 ││37 │38 │39 ││3A   │   │3B   │3C                         │3D   │   │3E   ││3F │3G │3H ││3I │3J │3K │3L ││30 │31 │
└───┴───┘└───┴───┴───┴───┘└───┴───┴───┘└─────┘   └─────┴───────────────────────────┴─────┘   └─────┘└───┴───┴───┘└───┴───┴───┴───┘└───┴───┘
                 ┌───────┐             ┌────────┐                                       ┌──────────┐             ┌───────┐
  2u Numpad Zero │36     │             │27      │ 2.25u LShift             2.75u RShift │2J        │             │3I     │ 2u Numpad Zero
                 └───────┘             └────────┘                                       └──────────┘             └───────┘
         ┌───┐                                    ┌───────────────────────────────────────┐                                  ┌───┐
         │   │ 2u                                 │3C                                     │ 10u Space                        │   │ 2u
         │02 │ Numpad                             └───────────────────────────────────────┘                                  │0T │ Numpad
         │   │ Plus                                                                                                          │   │ Plus
         ├───┤                                         ┌─────────┐┌─────┐┌─────────┐ 2.75 + 1.5 +                            ├───┤
         │   │ 2u                                      |3C       ||3C   ||3C       | 2.75 Split                              │   │ 2u
         │33 │ Numpad                                  └─────────┘└─────┘└─────────┘ Spacebar                                │3L │ Numpad
         │   │ Enter                                                                                                         │   │ Enter
         └───┘                                                                                                               └───┘
```
