# Matrix Diagram for TheDogKeyboard

Note that keys that are physically in columns are wired electrically as rows, and vice versa.

```
┌───┐   ┌───┬───┬───┬───┐ ┌───┬───┬───┬───┐ ┌───┬───┬───┬───┐┌───┬───┬───┐
│00 │   │10 │20 │30 │40 │ │50 │60 │70 │80 │ │90 │A0 │B0 │C0 ││D0 │E0 │F0 │
└───┘   └───┴───┴───┴───┘ └───┴───┴───┴───┘ └───┴───┴───┴───┘└───┴───┴───┘
┌───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───────┐┌───┬───┬───┐┌───┬───┬───┬───┐
│01 │11 │21 │31 │41 │51 │61 │71 │81 │91 │A1 │B1 │C1 │D1     ││E1 │F2 │F1 ││G0 │H0 │I0 │J0 │
├───┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─────┤├───┼───┼───┤├───┼───┼───┼───┤   ┌───┐
│02   │12 │22 │32 │42 │52 │62 │72 │82 │92 │A2 │B2 │C2 │D2   ││E2 │F4 │F3 ││G1 │H1 │I1 │J1 │   │   │
├─────┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴─────┤└───┴───┴───┘├───┼───┼───┼───┤   │J1 │ 2u Numpad Plus
│03    │13 │23 │33 │43 │53 │63 │73 │83 │93 │A3 │B3 │D3      │             │G2 │H2 │I2 │J3 │   │   │
├──────┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴────────┤    ┌───┐    ├───┼───┼───┼───┤   ├───┤
│04      │14 │24 │34 │44 │54 │64 │74 │84 │94 │A4 │D4        │    │F5 │    │G3 │H3 │I3 │J2 │   │   │
├────┬───┴┬──┴─┬─┴──┬┴───┼───┴┬──┴─┬─┴──┬┴───┼───┴┬────┬────┤┌───┼───┼───┐├───┼───┼───┼───┤   │J2 │ 2u Numpad Enter
│05  │15  │25  │35  │45  │55  │65  │75  │95  │A5  │C3  │D5  ││E3 │E4 │E5 ││G4 │H4 │I4 │J4 │   │   │
└────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┴────┘└───┴───┴───┘└───┴───┴───┴───┘   └───┘
┌────┬────┬────┬────────────────────────┬────┬────┬────┬────┐             ┌───────┐
│05  │15  │25  │55                      │95  │A5  │C3  │D5  │ Standard    │G4     │ 2u Numpad Zero
└────┴────┴────┴────────────────────────┴────┴────┴────┴────┘             └───────┘
```
