```
 /* 
  *       ┌─────┬─────┬─────┬─────┬─────┐             ┌─────┬─────┬─────┬─────┬─────┐
  *       │  Q  │  W  │  F  │  P  │  G  │    BASE     │  J  │  L  │  U  │  Y  │  ;  │
  *       │     │     │     │     │     │    LAYER    │     │     │     │     │     │
  * ┌─────┼─────┼─────┼─────┼─────┼─────┤   ┌─────┐   ├─────┼─────┼─────┼─────┼─────┼─────┐
  * │ TAB │  A  │  R  │  S  │  T  │  D  │   │ TAP │   │  H  │  N  │  E  │  I  │  O  │ ENT │
  * │ HYP │     │     │     │     │     │   │ HOLD│   │     │     │     │     │     │ HYP │
  * └─────┼─────┼─────┼─────┼─────┼─────┤   └─────┘   ├─────┼─────┼─────┼─────┼─────┼─────┘
  *       │  Z  │  X  │  C  │  V  │  B  │             │  K  │  M  │  ,  │  .  │  /  │
  *       │ SFT │ CTL │ ALT │ CMD │     │             │     │ CMD │ ALT │ CTL │ SFT │
  *       └─────┴─────┴─────┼─────┼─────┼─────┐ ┌─────┼─────┼─────┼─────┴─────┴─────┘
  *                         │     │ ESC │     │ │ BAK │ SPC │     │
  *                         │ SYM │ SFT │ NUM │ │     │     │ NAV │
  *                         └─────┴─────┴─────┘ └─────┴─────┴─────┘
  *       ┌─────┬─────┬─────┬─────┬─────┐             ┌─────┬─────┬─────┬─────┬─────┐
  *       │  \  │  `  │  '  │  "  │  {  │     SYM     │  }  │  -  │  =  │  [  │  ]  │
  *       │     │     │     │     │     │    LAYER    │     │     │     │     │     │
  * ┌─────┼─────┼─────┼─────┼─────┼─────┤             ├─────┼─────┼─────┼─────┼─────┼─────┐
  * │     │  !  │  @  │  #  │  $  │  %  │             │  ^  │  &  │  *  │  (  │  )  │     │
  * │     │     │     │     │     │     │             │     │     │     │     │     │     │
  * └─────┼─────┼─────┼─────┼─────┼─────┤             ├─────┼─────┼─────┼─────┼─────┼─────┘
  *       │     │     │     │     │     │             │     │     │     │     │     │
  *       │     │     │     │     │     │             │     │     │     │     │     │
  *       └─────┴─────┴─────┼─────┼─────┼─────┐ ┌─────┼─────┼─────┼─────┴─────┴─────┘
  *                         │     │     │     │ │ DEL │     │     │
  *                         │     │     │     │ │     │     │     │
  *                         └─────┴─────┴─────┘ └─────┴─────┴─────┘
  *       ┌─────┬─────┬─────┬─────┬─────┐             ┌─────┬─────┬─────┬─────┬─────┐
  *       │     │     │     │     │ VOL │     NAV     │     │     │     │     │     │
  *       │     │     │     │     │ UP  │    LAYER    │     │     │     │     │     │
  * ┌─────┼─────┼─────┼─────┼─────┼─────┤             ├─────┼─────┼─────┼─────┼─────┼─────┐
  * │     │ CTL │ CTL │ CMD │ CMD │ VOL │             │  ←  │  ↓  │  ↑  │  →  │CAPS │     │
  * │     │ + ↓ │ + ↑ │ + ` │ +TAB│ DOWN│             │     │     │     │     │LOCK │     │
  * └─────┼─────┼─────┼─────┼─────┼─────┤             ├─────┼─────┼─────┼─────┼─────┼─────┘
  *       │     │     │     │     │ MUTE│             │     │     │     │     │     │
  *       │     │     │     │     │     │             │     │     │     │     │     │
  *       └─────┴─────┴─────┼─────┼─────┼─────┐ ┌─────┼─────┼─────┼─────┴─────┴─────┘
  *                         │     │     │     │ │     │     │     │
  *                         │     │     │     │ │     │     │     │
  *                         └─────┴─────┴─────┘ └─────┴─────┴─────┘
  *       ┌─────┬─────┬─────┬─────┬─────┐             ┌─────┬─────┬─────┬─────┬─────┐
  *       │ F1  │ F2  │ F3  │ F4  │ F5  │     NUM     │ F6  │ F7  │ F8  │ F9  │ F10 │
  *       │ F11 │ F12 │     │     │     │    LAYER    │     │     │     │     │     │
  * ┌─────┼─────┼─────┼─────┼─────┼─────┤   ┌─────┐   ├─────┼─────┼─────┼─────┼─────┼─────┐
  * │     │  1  │  2  │  3  │  4  │  5  │   │ TAP │   │  6  │  7  │  8  │  9  │  0  │     │
  * │     │     │     │     │     │     │   │TAPx2│   │     │     │     │     │     │     │
  * └─────┼─────┼─────┼─────┼─────┼─────┤   └─────┘   ├─────┼─────┼─────┼─────┼─────┼─────┘
  *       │     │     │     │     │     │             │     │     │     │     │     │
  *       │     │     │     │     │     │             │     │     │     │     │     │
  *       └─────┴─────┴─────┼─────┼─────┼─────┐ ┌─────┼─────┼─────┼─────┴─────┴─────┘
  *                         │     │     │     │ │     │     │     │
  *                         │     │     │     │ │     │     │     │
  *                         └─────┴─────┴─────┘ └─────┴─────┴─────┘
  */
```


