# Matrix Diagram for Ramlord WITF

```
┌───┬───┬───┬───┐   ┌───┐ ┌───┬───┬───┬───┐┌───┬───┐       ┌───┬───┐ ┌───┬───┬───┬───┐   ┌───┬───┬───┐┌───┬───┐
│00 │10 │01 │11 │   │02 │ │12 │03 │13 │04 ││15 │06 │       │16 │07 │ │17 │08 │18 │09 │   │19 │0A │1A ││0B │1B │
└───┴───┴───┴───┘   └───┘ └───┴───┴───┴───┘└───┴───┘       └───┴───┘ └───┴───┴───┴───┘   └───┴───┴───┘└───┴───┘
┌───┬───┬───┬───┐   ┌───┬───┬───┬───┬───┬───┬───┐    ┌───┬───┬───┬───┬───┬───┬───┬───┐   ┌───┬───┬───┐┌───┬───┐
│20 │30 │21 │31 │   │22 │32 │23 │33 │24 │34 │25 │    │35 │26 │36 │27 │37 │28 │38 │29 │   │39 │2A │3A ││2B │3B │
├───┼───┼───┼───┤  ┌┴───┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┘   ┌┴──┬┴──┬┴──┬┴──┬┴──┬┴──┬┴──┬┴───┴┐  ├───┼───┼───┤├───┼───┤
│40 │50 │41 │51 │  │42   │52 │43 │53 │44 │54 │      │45 │46 │56 │47 │57 │48 │58 │49   │  │59 │4A │5A ││4B │5B │
├───┼───┼───┼───┤ ┌┴─────┴┬──┴┬──┴┬──┴┬──┴┬──┴┐     └─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─────┴┐ └───┴───┴───┘├───┼───┤
│60 │70 │61 │71 │ │62     │72 │63 │73 │64 │74 │       │65 │66 │76 │67 │77 │68 │69      │              │6B │7B │
├───┼───┼───┼───┤┌┴───────┴┬──┴┬──┴┬──┴┬──┴┬──┴┐     ┌┴──┬┴──┬┴──┬┴──┬┴──┬┴──┬┴─────┬──┴┐    ┌───┐    ├───┼───┤
│80 │90 │81 │91 ││82       │92 │83 │93 │84 │94 │     │95 │86 │96 │87 │97 │88 │89    │98 │    │8A │    │8B │9B │
├───┼───┼───┼───┤├─────┬───┴──┬┴───┴┬──┴───┴─┬─┴─┐   ├───┴───┴──┬┴───┴┬──┴───┴────┬─┴───┤┌───┼───┼───┐├───┼───┤
│A0 │B0 │A1 │B1 ││A2   │      │A3   │A4      │B4 │   │A6        │A7   │           │A9   ││B9 │AA │BA ││AB │BB │
└───┴───┴───┴───┘└─────┘      └─────┴────────┴───┘   └──────────┴─────┘           └─────┘└───┴───┴───┘└───┴───┘
─ Numpad Options ──────────────────────────────────────
  [Standard]                           [Flipped]
┌───┬───┬───┬───┐                     ┌───┬───┬───┬───┐                      ┌───────┐
│20 │30 │21 │31 │                     │20 │30 │21 │31 │                      │29     │ 2u Backspace
├───┼───┼───┼───┤                     ├───┼───┼───┼───┤                      └───────┘
│40 │50 │41 │   │                     │   │50 │41 │51 │
├───┼───┼───┤51 │ ─ 2u Numpad Plus ── │40 ├───┼───┼───┤
│60 │70 │61 │   │                     │   │70 │61 │71 │
├───┼───┼───┼───┤                     ├───┼───┼───┼───┤                      ┌──────────┐
│80 │90 │81 │   │                     │   │90 │81 │91 │                      │89        │ 2.75u RShift
├───┴───┼───┤91 │ ─ 2u Numpad Enter ─ │80 ├───┼───┴───┤                      └──────────┘
│A0     │A1 │   │                     │   │B0 │B1     │
└───────┴───┴───┘                     └───┴───┴───────┘
    └────────────── 2u Numpad Zero ───────────────┘
```
