# Matrix Diagram for RGBKB Pan

```
┌──┐                                            ┌──┐
│E1│                                            │E2│
└──┘                                            └──┘

Top Row Options ─────────────────────────────────────
  Exx
┌─────┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬─────┐
│00   │01 │02 │03 │04 │05 │06 │07 │08 │09 │0A │0C   │
└─────┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴─────┘

  Sxx
┌───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┐
│00 │01 │02 │03 │04 │05 │06 │07 │08 │09 │0A │0B │0C │
└───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┘
                                            ┌───────┐
                                            │0C     │
                                            └───────┘

Middle Three Rows Options ───────────────────────────
  xEx
┌─────┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬─────┐
│10   │11 │12 │13 │14 │15 │16 │17 │18 │19 │1A │1B   │
├─────┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼─────┤
│20   │21 │22 │23 │24 │25 │26 │27 │28 │29 │2A │2B   │
├─────┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼─────┤
│30   │31 │32 │33 │34 │35 │36 │37 │38 │39 │3A │3C   │
└─────┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴─────┘

  xSx
┌─────┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬─────┐ ┌─────┐
│10   │11 │12 │13 │14 │15 │16 │17 │18 │19 │1A │1B   │ │     │
├─────┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬────┤ └┐1B  │ ISO Enter
│20    │21 │22 │23 │24 │25 │26 │27 │28 │29 │2A │2B  │  │    │
├───┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬───┤  └────┘
│30 │31 │32 │33 │34 │35 │36 │37 │38 │39 │3A │3B │3C │
└───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┘
┌───────┐
│30     │
└───────┘

  xAx - xSx, ANSI Only
  xIx - xSx, ISO Only

Bottom Row Options ──────────────────────────────────

  xxG
┌─────┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬─────┐
│40   │41 │42 │43 │44 │45 │46 │47 │48 │49 │4A │4C   │ 1.5u/10x 1u/1.5u
└─────┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴─────┘

  xxE
┌─────┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬─────┐
│40   │41 │42 │43 │44 │45 │46 │47 │48 │49 │4A │4C   │ 1.5u/10x 1u/1.5u
└─────┴───┴───┴───┴───┴───┴───┴───┴───┴───┴───┴─────┘
  ┌───┬─────┬───────────────────────────┬─────┬───┐
  │40 │41   │46                         │4A   │4C │ 1u/1.5u/7u/1.5u/1u
  └───┴─────┴───────────────────────────┴─────┴───┘
  ┌───┬─────┬─────┬───────┬───────┬─────┬─────┬───┐
  │40 │41   │43   │45     │47     │48   │4A   │4C │ 1u/1.5u/1.5u/2u/2u/1.5u/1.5u/1u
  └───┴─────┴─────┴───────┴───────┴─────┴─────┴───┘
                      ┌───────┐
                      │46     │ 2u
                      └───────┘

  xxK - Same as xxE, with HHKB-style blockers

  xxS
┌─────┬─────┬───────────────────────────┬─────┬─────┐
│40   │41   │46                         │4A   │4C   │ 1.5u/1.5u/7u/1.5u/1.5u
└─────┴─────┴───────────────────────────┴─────┴─────┘
┌────┬───┬────┬────┬────────┬──────────┬───┬───┬────┐
│40  │41 │42  │43  │45      │47        │49 │4A │4C  │ 1.25u/1u/1.25u/1.25u/2.25u/2.75u/1u/1u/1.25u
└────┴───┴────┴────┴────────┴──────────┴───┴───┴────┘
┌────┬───┬────┬────────────────────────┬───┬───┬────┐
│40  │41 │42  │46                      │49 │4A │4C  │ 1.25u/1u/1.25u/6.25u/1u/1u/1.25u
└────┴───┴────┴────────────────────────┴───┴───┴────┘
  xxH - Same as xxS, with HHKB-style blockers

  xxU - Universal, supports all R5 layouts
```
