# Matrix Diagram for KPrepublic XD96

```
Spaced Function Row ────────────────────────────────────────┐
┌───┐ ┌───┬───┬───┬───┐ ┌───┬───┬───┬───┐ ┌───┬───┬───┬───┐
│00 │ │01 │02 │03 │04 │ │06 │07 │08 │09 │ │0A │0B │0C │0D │
└───┘ └───┴───┴───┴───┘ └───┴───┴───┴───┘ └───┴───┴───┴───┘
                                                    ┌───────┐       ┌───────┐
                          2u Function Row Backspace │0D     │       │0G     │
                                                    └───────┘       └───────┘
┌───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┬───┐
│00 │01 │02 │03 │04 │05 │06 │07 │08 │09 │0A │0B │0C │0D │56 │0E │0F │0G │0H │
├───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┼───┤    ┌───────┐                            ┌───┐
│10 │11 │12 │13 │14 │15 │16 │17 │18 │19 │1A │1B │1C │1D │59 │1E │1F │1G │1H │    │1D     │ 2u Backspace               │   │
├───┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴───┼───┼───┼───┼───┤    └─┬─────┤      ┌─────┐               │1H │   ┌───┐
│20   │21 │22 │23 │24 │25 │26 │27 │28 │29 │2A │2B │2C │2D   │2E │2F │2G │2H │      │2D   │      │     │               │   │   │   │
├─────┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬──┴┬────┼───┼───┼───┼───┤   ┌──┴─────┤   ┌──┴┐3D  │               ├───┤   │2H │ 2u Numpad Plus
│30    │31 │32 │33 │34 │35 │36 │37 │38 │39 │3A │3B │3C │3D  │3E │3F │3G │3H │   │3D      │   │3C │    │               │   │   │   │
├────┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴─┬─┴───┴┬───┼───┼───┼───┼───┤   └────────┘   └───┴────┘   ┌───────┐   │3H │   ├───┤
│40  │41 │42 │43 │44 │45 │46 │47 │48 │49 │4A │4B │4C    │4D │4E │4F │4G │4H │    ANSI         ISO         │4E     │   │   │   │   │
├────┼───┴┬──┴─┬─┴───┴───┴───┴───┴───┴──┬┴───┴┬──┴──┬───┼───┼───┼───┼───┼───┤    Enter        Enter       └───────┘   └───┘   │4H │ 2u Numpad Enter
│50  │51  │52  │55                      │5A   │58   │5C │5D │5E │5F │5G │5H │                              2u Zero            │   │
└────┴────┴────┴────────────────────────┴─────┴─────┴───┴───┴───┴───┴───┴───┘                              on Shift Row       └───┘
┌────────┐                                   ┌───┬──────────┬───────┐
│40      │ 2.25u LShift      1u/2.75u RShift │4B │4D        │5E     │ 2u Numpad Zero
└────────┘                                   └───┴──────────┴───────┘
                                             ┌────┬────┬────┐
                             3x 1.25u RShift │4B  │4C  │4D  │
                                             └────┴────┴────┘
┌────┬────┬────┬────────────────────────┬────┬────┬────┬────┐
│50  │51  │52  │55                      │5A  │58  │5C  │5D  │ ANSI
└────┴────┴────┴────────────────────────┴────┴────┴────┴────┘
┌─────┬───┬─────┬───────────────────────┬─────┬─────┬───┬───┐
│50   │51 │52   │55                     │5A   │58   │5C │5D │ Tsangan
└─────┴───┴─────┴───────────────────────┴─────┴─────┴───┴───┘
┌─────┬─────┬───────────────────────────┬─────┬─────┬───┬───┐
│50   │51   │55                         │5A   │58   │5C │5D │ WKL
└─────┴─────┴───────────────────────────┴─────┴─────┴───┴───┘
      ┌───┬─────┬───────────────────────────┬─────┬───┐
      │51 │52   │55                         │58   │5C │ HHKB
      └───┴─────┴───────────────────────────┴─────┴───┘
```
